<script>
  import Error from './Error'
  import { submitWrapper } from '../utils/formUtils'
  import offline from '../stores/offline'

  export let values
  export let action
  export let online = true

  $: isOffline = online && $offline

  let loading
  let error

  function onSubmit(submitted) {
    loading = true
    for (const [key, value] of Object.entries(submitted)) {
      if (values[key].trim) submitted[key] = value.trim()
    }
    action(submitted)
      .catch(_e => (error = _e))
      .finally(() => (loading = false))
  }

  const INPUT_EL_TYPES = ['text', 'textarea', 'date']
</script>

<div
  class={`w-full max-w-xl p-8 m-auto transition-opacity` + (loading ? ' opacity-50 pointer-events-none' : '')}
>
  {#if error}
    <Error className="mb-4" {error} />
  {/if}
  <form
    class="max-w-lg m-auto"
    on:submit|preventDefault={submitWrapper(onSubmit)}
  >
    <fieldset disabled={loading}>
      {#if values}
        <slot name="header" />
        {#each Object.entries(values) as [name, value]}
          {#if INPUT_EL_TYPES.indexOf(value.type) !== -1}
            <div class="mb-4">
              <label class="label" for={name}>{value.label}</label>
              {#if value.type === 'text'}
                <input
                  class="input input-form"
                  type="text"
                  {name}
                  {...value.props}
                />
              {:else if value.type === 'date'}
                <input
                  class="input input-form"
                  type="date"
                  {name}
                  {...value.props}
                />
              {:else if value.type === 'textarea'}
                <textarea class="input input-form" {name} {...value.props} />
              {/if}
            </div>
          {:else if value.type === 'submit'}
            <button
              class="btn btn-blue shadow block m-auto"
              disabled={isOffline}
            >
              {value.label}
            </button>
            {#if isOffline}
              <p class="m-2 text-center">Necesitas internet para hacer esto.</p>
            {/if}
          {/if}
        {/each}
        <slot name="footer" />
      {:else}
        <slot />
      {/if}
    </fieldset>
  </form>
</div>
